const wxBugAlertBtnTxt = 'ALERT!';
var wxBugTimerAlertBlink = null;

function wxBugUpdateAlert() {
	if (wxBugGetBoolPref(wxBugPrefAlertsMode, false)) {
		var lu = wxBugGetCharPref(wxBugPrefAlertLastUpdate, 0);
		var inter = wxBugGetIntPref(wxBugPrefAlertInterval, wxBugDefaultInter);
		var res = wxBugGetCharPref(wxBugPrefAlertRes);
		
		var now = new Date();
	    var lastUpdate = new Date();
	    lastUpdate.setTime(lu);
	    wxBugLog('Alert last update = ' + lastUpdate);
	    wxBugLog('Alert interval = ' + inter);
	    wxBugLog('Alert diff: ' + (now.getTime() - lu));

	
		if (!(res) || wxBugIsDataExpired(lu, inter)) {
			// make http call
			wxBugGetAlert();
		}
		else {
			//read from cache
			//wxBugParseAlertData(res);
			wxBugLog('Alert cache');
		}
	}
}

function wxBugGetAlert() {
	var url = wxBugGetCharPref(wxBugPrefAlertUrl);
	if (url) {
		url = wxBugDeTokenizeUrl(url);
		wxBugLog('Alert http: ' + url);
		var ah = new wxBugAsyncHttp(url, 'wxBugParseAlertData');
	}
}

function wxBugParseAlertData(response) {
	wxBugLog('wxBugParseAlertData - ' + response);
	var data = response.split('|');
	var msgId = data[2]
	if ('0' != msgId) {
		//get last acknowledged alert and check if it is the same
		var ackMsgId = wxBugGetCharPref(wxBugPrefAlertAckMsgId, '0')
		if (msgId != ackMsgId) {
			wxBugSetCharPref(wxBugPrefAlertMsgId, msgId);
			wxBugSetBoolPref(wxBugPrefAlertActive, true);
			wxBugRaiseAlert();
		}
	}
	
	// write response to cache
	wxBugSetCharPref(wxBugPrefAlertRes, response);
	
	//set the last update time
	var now = new Date();
	wxBugSetCharPref(wxBugPrefAlertLastUpdate, now.getTime());
}

function wxBugRaiseAlert() {
	
	if (wxBugTimerAlertBlink) clearTimeout(wxBugTimerAlertBlink);
	
	if (wxBugIsActiveAlert()) {
		if (wxBugIsAlertDisplaying) {
			wxBugUpdateObUi();
		}
		else {
			wxBugDisplayAlert();
		}
				
		wxBugTimerAlertBlink = setTimeout('wxBugRaiseAlert()', 1000);
	}
	else 
		wxBugUpdateObUi();
}

function wxBugDisplayAlert() {
	var temperBtn = document.getElementById('wxBugTemperature');
	temperBtn.setAttribute('class', 'wxBugAlertBtn');
	temperBtn.setAttribute('value', wxBugAlertBtnTxt);
	wxBugIsAlertDisplaying = true;
}

function wxBugIsActiveAlert() {
	return wxBugGetBoolPref(wxBugPrefAlertActive, false);
}

function wxBugClearActiveAlert() {
	//set acknowledged alert to active alert
	wxBugSetCharPref(wxBugPrefAlertAckMsgId, wxBugGetCharPref(wxBugPrefAlertMsgId, '0'));
	wxBugSetBoolPref(wxBugPrefAlertActive, false);
}